<?php
/*
Plugin Name: Coastr widget
Description: Shows your favorites from Coastr feed.
Author: Otto
Version: 1.1
Author URI: http://ottodestruct.com
*/

function widget_coastr_init()
{	
	// Check for the required API functions
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
		return;	

	// main widget function
	function widget_coastr($args) {
		require_once(ABSPATH . WPINC . '/rss-functions.php');
		
		// get my options
		extract($args);
		$options = get_option('widget_coastr');
		$title = $options['title'];
		$user = $options['user'];
		$showbeers = $options['showbeers']; 
		$showpubs = $options['showpubs'];

		// start the widget		
		echo $before_widget;
		$title ? print($before_title . $title . $after_title) : null;
		echo '<div class="coastrwidget">';

		// print the beer list		
		if ($showbeers)
		{
			$feed = "http://coastr.com/rss/user/".$user;
			$feedContent = @fetch_rss($feed);
			$feedItems = $feedContent->items;
			echo "<h3 class='CoastrHeader'>Favorite Beers</h3>\n";
			echo "<ul class='CoastrList'>";
			foreach ($feedItems as $key => $row) {
				echo "<li class='CoastrListItem'><a href=\"".$row['link']."\" title=\"".htmlspecialchars($row['description'])."\">".htmlspecialchars($row['title'])."</a></li>\n";
			}
			echo "</ul>";
		}
		
		// print the pubs list
		if ($showpubs)
		{
			$feed = "http://coastr.com/rss/user_places/".$user;
			$feedContent = @fetch_rss($feed);
			$feedItems = $feedContent->items;
			echo "<h3 class='CoastrHeader'>Favorite Pubs</h3>\n";
			echo "<ul class='CoastrList'>";
			foreach ($feedItems as $key => $row) {
				echo "<li class='CoastrListItem'><a href=\"".$row['link']."\" title=\"".htmlspecialchars($row['description'])."\">".htmlspecialchars($row['title'])."</a></li>\n";
			}
			echo "</ul>";
		}
		
		echo "</div>";
		echo $after_widget;
	}

	// control panel
	function widget_coastr_control() {
		$options = $newoptions = get_option('widget_coastr');
		if ( $_POST["coastr-submit"] ) {
			$newoptions['title'] = trim(strip_tags(stripslashes($_POST["coastr-title"])));
			$newoptions['user'] = trim(strip_tags(stripslashes($_POST["coastr-user"])));
			$newoptions['showbeers'] = isset($_POST["coastr-showbeers"]);
			$newoptions['showpubs'] = isset($_POST["coastr-showpubs"]);
		}
		if ( $options != $newoptions ) {
			$options = $newoptions;
			update_option('widget_coastr', $options);
		}
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$user = htmlspecialchars($options['user'], ENT_QUOTES);
		$showbeers = $options['showbeers'] ? 'checked="checked"' : '';
		$showpubs = $options['showpubs'] ? 'checked="checked"' : '';		
		
	?>
		<p><label for="coastr-title">Give the widget a title (optional):</label>
		<input style="width: 100%;" id="coastr-title" name="coastr-title" type="text" value="<?php echo $title; ?>" /></p>
		<p><label for="coastr-user">Enter the user number of the Coastr user <br/>(look at the URL for "My Page" on Coastr):</p>
		<input style="width: 100%;" id="coastr-user" name="coastr-user" type="text" value="<?php echo $user; ?>" /></p>
		<p style='text-align: center; line-height: 30px;'><label for="coastr-showbeers">Show beers? <input class="checkbox" type="checkbox" <?php echo $showbeers; ?> id="coastr-showbeers" name="coastr-showbeers" /></label></p>
		<p style='text-align: center; line-height: 30px;'><label for="coastr-showpubs">Show pubs? <input class="checkbox" type="checkbox" <?php echo $showpubs; ?> id="coastr-showpubs" name="coastr-showpubs" /></label></p>
		<input type="hidden" id="coastr-submit" name="coastr-submit" value="1" />
	<?php
	}
	
	register_sidebar_widget('Coastr', 'widget_coastr');
	register_widget_control('Coastr', 'widget_coastr_control', 400, 250);
}
	
// Tell Dynamic Sidebar about our new widget and its control
add_action('plugins_loaded', 'widget_coastr_init');

?>
